/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package cz.muni.fi.pb138.xpathdemo;

import java.io.File;
import java.io.IOException;
import javax.xml.namespace.QName;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpression;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;
import org.w3c.dom.Document;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

/**
 *
 * @author tomp
 */
public class XPathEvaluator {

        /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws ParserConfigurationException, SAXException, IOException, XPathExpressionException {

        File input = null;

        if (args.length < 1) {
            System.err.println("Chybi argument se jmenem souboru pro " +
                    "zpracovani, pouzivam books.xml...");

            input = new File("books.xml");
        } else {
            input = new File(args[0]);
        }

        Document doc = getDocument(input);

        //System.out.println( doc.getDocumentElement().getTextContent());

        showSelectedNodeset(doc,
                "//book[author='Neal Stephenson']/title/text()");

        showSelectedNodeset(doc,
                "//book[author='Tomáš Pitner' and price > 5]/title/text()");

        showSelectedNodeset(doc,
                "//book[author='Tomáš Pitner']/preceding-sibling::book/title/text()");

        System.out.println("Evaluated as number " +
                selectByXPath(doc, "count(//book)", XPathConstants.NUMBER));

        System.out.println("Evaluated as boolean " +
                selectByXPath(doc, "count(//book)", XPathConstants.BOOLEAN));

        System.out.println("Evaluated as string " +
                selectByXPath(doc, "count(//book)", XPathConstants.STRING));

    }

    public static Document getDocument(File input) throws ParserConfigurationException, SAXException, IOException {
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        factory.setNamespaceAware(true); // never forget this!
        DocumentBuilder builder = factory.newDocumentBuilder();
        Document doc = builder.parse(input);
        return doc;
    }

    public static Object selectByXPath(Document doc, String path, QName resultType) throws XPathExpressionException {
        XPathFactory factory = XPathFactory.newInstance();
        XPath xpath = factory.newXPath();
        XPathExpression expr = xpath.compile(path);
        return expr.evaluate(doc, resultType);
    }

    public static void showNodeset(NodeList nodes) {
        for (int i = 0; i < nodes.getLength(); i++) {
            System.out.println("Node #" + i + ". " + nodes.item(i));
        }
    }

    public static void showSelectedNodeset(Document doc, String expr)
            throws XPathExpressionException {
        showNodeset((NodeList) selectByXPath(doc, expr, XPathConstants.NODESET));
    }
}
