/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.muni.fi.pb138.xpathdemo;

import java.io.File;
import java.io.IOException;
import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Map;
import javax.xml.namespace.NamespaceContext;
import javax.xml.namespace.QName;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpression;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;
import org.w3c.dom.Document;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

/**
 *
 * @author tomp
 */
public class XPathEvaluatorNS {

    private NamespaceContext nsContext;

    public XPathEvaluatorNS() {

        final Map<String, String> nsMapping = new HashMap<String, String>();
        // add PurchaseOrder NS mapping to prefix po
        nsMapping.put("po", "http://www.marchal.com/2006/po");
        // add standard mappings
        nsMapping.put("xml", "http://www.w3.org/XML/1998/namespace");
        nsMapping.put("xmlns", "http://www.w3.org/2000/xmlns/");

        nsContext = new NamespaceContext() {

            public String getNamespaceURI(String prefix) {
                if (prefix == null) {
                    throw new IllegalArgumentException(
                            "Do not have a prefix for prefix null");
                } else {
                    return nsMapping.get(prefix);
                }
            }

            public String getPrefix(String namespaceURI) {
                if (namespaceURI == null) {
                    throw new IllegalArgumentException(
                            "Do not have a prefix for NS URI null");
                } else {
                    for (Map.Entry<String, String> mapping : nsMapping.entrySet()) {
                        if (namespaceURI.equals(mapping.getValue())) {
                            return mapping.getKey();
                        }
                    }
                    return null;
                }
            }

            public Iterator getPrefixes(String namespaceURI) {
                Collection<String> prefixes = new HashSet<String>();
                for (Map.Entry<String, String> mapping : nsMapping.entrySet()) {
                    if (namespaceURI.equals(mapping.getValue())) {
                        prefixes.add(mapping.getKey());
                    }
                }
                return prefixes.iterator();
            }
        };
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws ParserConfigurationException, SAXException, IOException, XPathExpressionException {

        File input = null;

        if (args.length < 1) {
            System.err.println("Chybi argument se jmenem souboru pro " +
                    "zpracovani, pouzivam books.xml...");

            input = new File("books.xml");
        } else {
            input = new File(args[0]);
        }

        Document purchasesDoc = XPathEvaluator.getDocument(new File("purchase.xml"));
        new XPathEvaluatorNS().showSelectedNodesetNS(purchasesDoc,
                "//po:Price/text()");
    }

    public void showSelectedNodesetNS(Document doc, String expr)
            throws XPathExpressionException {

        XPathEvaluator.showNodeset((NodeList) selectByXPathNS(doc,
                expr, XPathConstants.NODESET));
    }

    public Object selectByXPathNS(Document doc,
            String path,
            QName resultType)
            throws XPathExpressionException {

        XPathFactory factory = XPathFactory.newInstance();
        XPath xpath = factory.newXPath();
        xpath.setNamespaceContext(nsContext);
        XPathExpression expr = xpath.compile(path);
        return expr.evaluate(doc, resultType);
    }
}
